# Official Implementation of Domain Generalization via Pareto Optimality Gradient Matching

## Environment Setup
```
python3 -m venv .env
source .env/bin/activate
python -m pip install -U pip
pip install domainbed/requirements.txt
```

## Data Setup

For the download procedure in ```./bash/download_dataset.sh```

## Simulation Conducting
The simulation and sweeping code can be found in ./bash and ./bash2

An exmple of bash code for training is:
```
CUDA_VISIBLE_DEVICES=0 python -m domainbed.scripts.train \
--data_dir ./domainbed/data/ \
--dataset DomainNet \
--algorithm POGM \   
--test_envs 0 \   
--output_dir ./train_output/92f58bc4f644512bf6d961d72881f06ax \
--trial_seed 2 \
--hparams_seed 0 \        
--seed 1176768576 \       
--hparams '{"batch_size": 32, "pogm_update": 1, "pogm_c": 0.5, "class_balanced": false, "data_augmentation": true, "lr": 5e-05, "meta_lr": 0.5, "nonlinear_classifier": false, "resnet18": false, "resnet_dropout": 0.0, "weight_decay": 0.0}' \
--wandb \
--steps 50000
```

## Algorithm Structure
- POGM: our proposed algorithm
- POGM_T: the test version of POGM, including the tracking utilities for gradient angle and norm.
- ERM_T: the test version of ERM, including the tracking utilities for gradient angle and norm.
- Fish_T: the test version of Fish, including the tracking utilities for gradient angle and norm.
- Fishr_T: the test version of Fishr, including the tracking utilities for gradient angle and norm.

## Wandb 
If you want to track your experiment, consider use ```--wandb``` args, toggle it to use the wandb along with a automated folder structure.

## Citation
```

```